from farmer.communication import Communication
from farmer.file import File
import urllib.parse


class Farmer:

    File = File()
    Comm = Communication()
    jobID = None
    jobCollectionUUID = None

    def __init__(self, servAddr):

        self.Comm.addr = servAddr

    def pushFile(self, path):
        self.File.filePath = path
        for chunk in self.File.GetChunk():

            self.Comm.send(chunk, self.File.GetFileName(), self.jobID,self.jobCollectionUUID)

    def createJob(self, data):

        self.jobID = self.Comm.sendCreate(data)
        print(self.jobID)

    def createJobCollection(self):
        self.jobCollectionUUID = self.Comm.sendCreateJobCollection()
        return self.jobCollectionUUID

    def releaseJob(self):
        message = {
            "jobID": self.jobID,
            "jobCollectionUUID": self.jobCollectionUUID
            }
        self.jobID = self.Comm.sendRelease(message)

    def getLink(self):
        data = {
            "jobCollectionUUID": self.jobCollectionUUID
            }
        url = urllib.parse.urljoin(self.Comm.addr, self.Comm.getJobLink(data))
        return url + "&key=" + self.Comm.key
