####  STAGE Plugin - Author: Marcin Brauer - Copyright: TrapDoor Creative 2022 - ver. 1.2.5


import BwApi
import threading

import sys
import os
import json
import tempfile
import time
import shutil
import contextlib

import webbrowser

import subprocess

import requests
import re

from farmer.farmer import Farmer

loop = 0
for location in sys.path:
    if (re.search('main', location)):
        _plugin_path = sys.path[loop-1]
    
    loop += 1

with open(os.path.join(_plugin_path, "main", "full_log.txt"), 'a') as full_log_file:
    with contextlib.redirect_stdout(full_log_file):

        handle = -1
        print("Testing")

        # Settings window size
        rect = BwApi.WndRect(660, 80, 600, 630)
        # Render window size
        rect1 = BwApi.WndRect(660, 80, 600, 630)


        CREATE = BwApi.BW_API_EVENT_HTML_CREATE
        CLOSE = BwApi.BW_API_EVENT_HTML_CLOSE
        MSG = BwApi.BW_API_EVENT_HTML_MSG
        UNCAUGHT_EXCEPTION = BwApi.BW_API_EVENT_HTML_UNCAUGHT_EXCEPTION


        _plugin_version = "1.2.5"
        _plugin_path = ""
        _zmienna = 0

        ####### scene.render.image_settings.color_mode = "RGBA" if support_alpha(format) else "RGB"

        _stage_open = 0
        _stage_open_process = None
        _action_listener_on = 0
        _include_avatar = 0

        _file_ext = ".glb"

        _stage_path = ""
        _model_path = ""
        _APIKey = ""
        _file_path = ""
        _export_scene_format_json = ""

        _history_garment_id = ''
        _history_colorway_id = ''

        _API_Colorway_array = dict()

        _batch_renderer = dict()
        _batch_renderer_json_import = dict()
        _batch_renderer_export_params = dict()
        _batch_renderer_currentItem = ''

        handle = ''

        _temp_export_settings = tempfile.TemporaryDirectory()

        _farmer_cloud_rendering = False
        _farmer_reference_link = ''
        _farmer_user_uid = ''
        _farmer_url = "https://cloud.stage3d.app"

        _API_SnaphotId = ''

        _resourcePath = os.path.dirname(os.path.realpath(__file__))

        #   BwApi.WndMessageBox(msg, BwApi.BW_API_MB_OK)
        #   res = BwApi.WndMessageBox("Are you sure you want to leave this window?", BwApi.BW_API_MB_YESNO)

        class CallbackEvent(BwApi.CallbackBase):
            def Run(self, garment_id, callback_id, data_string):
                global handle

                if not handle:
                    style = json.dumps({"allow_resize": False,
                                        "enable_maximize": False,
                                        "enable_minimize": False}
                                    )
                    handle = BwApi.WndHTMLCreateUrl('/index.html',
                                                    'Window API Sample',
                                                    style,
                                                    rect
                                                    )
                return 0

        class SessionCallback(BwApi.CallbackBase):
            def Run(self, garment_id, callbackId, dataString):
                global handle
                global _resourcePath
                global _action_listener_on
                global _history_garment_id
                global _history_colorway_id
                global _zmienna
                global _stage_open
                global _stage_open_process
                global _stage_path
                global _file_path
                global _model_path
                global _APIKey
                global _include_avatar
                global _export_scene_format_json
                global _API_Colorway_array
                global _file_ext


                global _temp_export_settings
                global _plugin_path

                global _batch_renderer
                global _batch_renderer_json_import
                global _batch_renderer_export_params
                global _batch_renderer_currentItem

                global _farmer_cloud_rendering
                global _farmer_url
                global _farmer_reference_link
                global _farmer_user_uid

                global _API_SnaphotId

                #print('Callback: ' + str(callbackId))
                if (callbackId == 0):
                    debug_log = []
                    #if os.path.exists(os.path.join(_resourcePath, "STAGE_Config.json")):          
                    debug_log.append("Callback 0 ->> PATH: " + os.path.join(_plugin_path, "main", "STAGE_Config.json"))
                    debug_log.append("Callback 0 ->> Does Path Exist: " + str(os.path.exists(os.path.join(_plugin_path, "main", "STAGE_Config.json"))))
                    if os.path.exists(os.path.join(_plugin_path, "main", "STAGE_Config.json")):
                        with open(os.path.join(_plugin_path, "main", "STAGE_Config.json")) as config_file:
                        #with open(os.path.join(_resourcePath, "STAGE_Config.json")) as config_file:
                            settings_data = json.load(config_file)
                            config_file.close()

                        with open(os.path.join(_plugin_path, "main", "debug_log.txt"), 'a') as debug_file:
                            debug_log.append("Callback 0 ->> Inside condition. Loaded settings: " + str(settings_data))
                            debug_file.write(str(debug_log))
                            debug_file.close()

                        _stage_path = settings_data["stage_path"]

                        SKU = "stage_export"

                        _model_path = settings_data["model_path"]
                        
                        if _model_path == '':
                            _model_path = _temp_export_settings.name
                            print('----> Model Path: ', _model_path)
                        elif not os.path.exists(_model_path):
                            print('----> No directory. Creating one.')
                            os.makedirs(_model_path)

                        _APIKey = settings_data["APIKey"]

                        _file_path = os.path.join(os.path.normpath(_model_path), SKU + _file_ext)

                        if (settings_data["updates_on"] == "true"):
                            _action_listener_on = 1
                        else:
                            _action_listener_on = 0

                        _export_scene_format_json = "ExportGltf.json"

                        if (settings_data["avatar_on"] == "true"):
                            _include_avatar = 1
                        else:
                            _include_avatar = 0

                        #_update_API_endpoints()
                    else:
                        if (os.name == "nt"):
                            _stage_path = "C:/Program Files (x86)/STAGE 3D/STAGE.exe"
                            _model_path = tempfile.TemporaryDirectory().name
                        elif (os.name == "posix"):
                            _stage_path = "/Applications/STAGE.app/Contents/MacOS/STAGE-Mac-Shipping"
                            _model_path = tempfile.TemporaryDirectory().name
                        BwApi.WndMessageBox("Warning: \n\nYour STAGE plugin is not configured! \n\nPlease go to Plugins->STAGE->Settings... to complete setup.", BwApi.BW_API_MB_OK)

                    _history_garment_id = garment_id
                    _history_colorway_id = BwApi.ColorwayCurrentGet(garment_id)

                elif (callbackId == 1):
                    _zmienna = 0

                    with open(os.path.join(_resourcePath, _export_scene_format_json)) as data_file:
                        export_params = json.load(data_file)
                        if _include_avatar == 1:
                            export_params["include_avatar"] = True
                        export_params["path"] = _file_path

                    BwApi.RenderExport3DObject(garment_id, json.dumps(export_params))

                    _API_json_data = dict()
                    
                    _API_json_data['ModelFile'] = os.path.join(_file_path)

                    with open(os.path.join(os.path.normpath(_temp_export_settings.name), "API.json"), 'w') as _API_file:
                        json.dump(_API_json_data, _API_file)

                    #param_path = '-Settings=\"' + os.path.join(os.path.normpath(_model_path), 'API.json') + '\"'

                    param_path = '-Settings=\"' + str(os.path.join(os.path.normpath(_temp_export_settings.name), 'API.json')) + '\"'
                    
                    # Depreciated method of call just the model file
                    #param_path = '-ModelFile=\"' + _file_path.replace("\\", "/") + '\"'

                    if (_stage_open == 0):
                        #print("---> STAGE path: ", _stage_path, param_path)    
                        #about_msg = '%s -Settings="%s"' % (os.path.normpath(_stage_path), os.path.join(os.path.normpath(_model_path), 'API.json'))
                        _stage_open_process = subprocess.Popen([os.path.normpath(_stage_path), param_path]) 
                        #_stage_open_process = subprocess.Popen(['%s -Settings="%s"' % (os.path.normpath(_stage_path), os.path.join(os.path.normpath(_model_path), 'API.json'))], shell=True)   
                        _stage_open = 1


                elif (callbackId == 2):
                    _stage_open = 0
                    BwApi.UpdateSessionFunctionRequest_v2('com.trapdoor.stage3d', 1, "Launch STAGE")

                # Open STAGE 3D Settings window
                elif (callbackId == 5):
                    open_settings_window()

                # Open STAGE 3D Render Setup window
                elif (callbackId == 6):
                    _zmienna = 3
                    _update_status_file(0, 0, "Loading...", 0)
                    open_rendering_window()

                elif (callbackId == 3):
                    _update_API_endpoints()


                # Process json return from Stage 3D Settings window
                elif (callbackId == 7):
                    settings_data = json.loads(dataString)
                    #print("SETTINGS: ", settings_data)
                    if (settings_data["getAPI"] == 1): 
                        _API_URL = "https://us-central1-stage-3782d.cloudfunctions.net/"
                        #_API_Headers = {"hardwaretoken": "Browzwear API Retrieval"}

                        _API_PluginEndpoint = 'api/auth/getkey'

                        _API_Object = {'email': settings_data['email'], 'password': settings_data['pass']}

                        try:
                            _API_Return_Endpoints = requests.post(url = _API_URL + _API_PluginEndpoint, json=_API_Object, timeout = 2)
                            #print("Status: ", _API_Return_Endpoints.status_code)
                            #print("Return values: ", _API_Return_Endpoints.text)
                            if (_API_Return_Endpoints.status_code != 200):
                                #BwApi.WndHTMLClose(handle)
                                BwApi.WndMessageBox(str(json.loads(_API_Return_Endpoints.text)["message"]), BwApi.BW_API_MB_OK)
                                return
                            settings_data["APIKey"] = json.loads(_API_Return_Endpoints.text)["API"]
                            settings_data["getAPI"] = 0
                            del settings_data['email']
                            del settings_data['pass']
                            BwApi.UpdateSessionFunctionRequest_v2('com.trapdoor.stage3d', 7, json.dumps(settings_data))
                            BwApi.WndMessageBox("API Key retrieved succcesfully!", BwApi.BW_API_MB_OK)
                            pass
                        except requests.Timeout:
                            time.sleep(2)
                            _API_Return_Endpoints = requests.post(url = _API_URL + _API_PluginEndpoint, json=_API_Object, timeout = 5)
                            if (_API_Return_Endpoints.status_code != 200):
                                BwApi.WndMessageBox(str(json.loads(_API_Return_Endpoints.text)["message"]), BwApi.BW_API_MB_OK)
                                return
                            settings_data["APIKey"] = json.loads(_API_Return_Endpoints.text)["API"]
                            settings_data["getAPI"] = 0
                            del settings_data['email']
                            del settings_data['pass']
                            BwApi.UpdateSessionFunctionRequest_v2('com.trapdoor.stage3d', 7, json.dumps(settings_data))
                            BwApi.WndMessageBox("API Key retrieved succcesfully!", BwApi.BW_API_MB_OK)
                            pass
                        except requests.ConnectionError:
                            print("Connection Failed")
                            BwApi.WndMessageBox("Connection to STAGE API server failed. Please try again.", BwApi.BW_API_MB_OK)
                            pass
                    else:
                        if 'email' in settings_data:
                            del settings_data['email']
                        if 'pass' in settings_data:
                            del settings_data['pass']
                        del settings_data["getAPI"]
                        if (settings_data["updates_on"] == "true"):
                            _action_listener_on = 1
                        else:
                            _action_listener_on = 0
                        #with open(os.path.join(_resourcePath, "STAGE_Config.json"), 'w') as config_file:
                        with open(os.path.join(_plugin_path, "main", "STAGE_Config.json"), 'w') as config_file:
                            json.dump(settings_data, config_file)
                        BwApi.UpdateSessionFunctionRequest_v2('com.trapdoor.stage3d', 0, "Update config")
                        BwApi.WndHTMLClose(handle)


                # Popup windows with About plugin info
                elif (callbackId == 8):
                    about_msg = "STAGE Plugin \n\nVer.: " + _plugin_version +"\n\nCopyright: TrapDoor Creative\nAuthor: Marcin Brauer \n\nMore info at: https://stage3d.app"
                    BwApi.WndMessageBox(about_msg, BwApi.BW_API_MB_OK)

                elif (callbackId == 9):
                    if (_history_garment_id != BwApi.GarmentId()) | (_history_colorway_id != BwApi.ColorwayCurrentGet(BwApi.GarmentId())):
                        BwApi.UpdateSessionFunctionRequest_v2('com.trapdoor.stage3d', 1, "Launch STAGE")
                        _history_garment_id = garment_id
                        _history_colorway_id = BwApi.ColorwayCurrentGet(garment_id)

                # Process json return from Stage 3D Settings window
                elif (callbackId == 10):
                    # loading return from Rendering Settings User Interface
                    _batch_renderer_json_import = json.loads(dataString)

                    # Loading 3D export parameter json file
                    with open(os.path.join(_resourcePath, _export_scene_format_json)) as data_file:
                        _batch_renderer_export_params = json.load(data_file)
                        if _batch_renderer_json_import["IncludeAvatar"] == 1:
                            _batch_renderer_export_params["include_avatar"] = True
                        #_batch_renderer_export_params["path"] = _file_path

                    #_batch_renderer_export_params["include_avatar"] = False
                    _update_status_file(1, 15, "Preparing for render: <br>Exporting colorways", 0)

                    # Saving temporary snapshot of current Garment simulation
                    # print('---->>> Getting all snapshots for garment: ', BwApi.GarmentSnapshotIdsEx(garment_id))
                    #print('->>>> Snapshot before delete: ', BwApi.SnapshotInfoGet(garment_id, 'STAGE'))
                    #_API_SnaphotId = BwApi.SnapshotDelete(garment_id, 'STAGE')
                    #print('->>>> Snapshot after delete: ', BwApi.SnapshotInfoGet(garment_id, "STAGE"))

                    for snapshotId in BwApi.GarmentSnapshotIdsEx(garment_id):
                        
                        snapshotInfo = BwApi.SnapshotInfoGet(garment_id, snapshotId)
                        if json.loads(snapshotInfo)['name'] == 'STAGE':
                            print('--->>> Old snapshot deleted')
                            BwApi.SnapshotDelete(garment_id, snapshotId)
                           
                    _API_SnaphotId = BwApi.SnapshotSave(garment_id, 'STAGE')
                    #print('->>>> Snapshot after save: ', BwApi.SnapshotInfoGet(garment_id, _API_SnaphotId))

                    _batch_renderer_currentItem = _batch_renderer_json_import["ColowayIds"][0]
                    #print("CurrentItem: " + str(_batch_renderer_currentItem))

                    _zmienna = 10

                elif (callbackId == 11):
                    # ----> Changing colorway
                    print("----> chagning colowary to: ", str(dataString))
                    BwApi.ColorwayCurrentSet(garment_id, int(dataString))

                    BwApi.GarmentDressEx(garment_id, '{"operation_mode": "sync"}')
                    #if BwApi.ColorwayCurrentGet(garment_id) == int(dataString):
                    #    print("----> Colorway is already set")
                    #else:
                        #BwApi.SnapshotLoad(garment_id, _API_SnaphotId)

                    #    BwApi.ColorwayCurrentSet(garment_id, int(dataString))

                    #    BwApi.GarmentDressEx(garment_id, '{"operation_mode": "sync"}')
                        #BwApi.GarmentDress(garment_id)
                        #BwApi.GarmentFinish(garment_id)
                        #BwApi.SnapshotLoad(garment_id, 'STAGE')
                        
                    print("----> loading snapshot")
                    _zmienna = 11
                    # 11 DONE

                elif (callbackId == 12):
                    # ----> Exporting 3D object
                    print("Export parameters: ", json.dumps(_batch_renderer_export_params))
                    BwApi.RenderExport3DObject(garment_id, json.dumps(_batch_renderer_export_params))
                    time.sleep(1)
                    _zmienna = 12
                    # 12 DONE

                elif (callbackId == 13):
                    # ----> Launching STAGE rendering
                    with open(os.path.join(os.path.normpath(_temp_export_settings.name), "API.json"), 'w') as _API_file:
                        json.dump(_batch_renderer, _API_file)

                    param_path = '-Settings=\"' + str(os.path.join(os.path.normpath(_temp_export_settings.name), 'API.json')) + '\"'
                    
                    #param_path = '-Settings=\"' + os.path.join(os.path.normpath(_model_path), 'API.json') + '\"'
                # subprocess.Popen(['%s -Settings="%s"' % (_stage_path, os.path.join(os.path.normpath(_model_path), 'API.json'))], shell=True)   

                    subprocess.Popen([_stage_path, param_path])

                    _zmienna = 13


                elif (callbackId == 14):
                    # BwApi.SnapshotDelete(garment_id, 'STAGE')
                    BwApi.SnapshotDelete(garment_id, _API_SnaphotId)
                    _update_status_file(1, 100, "Done", 1)

                elif (callbackId == 15):
                    BwApi.WndMessageBox("You can check job status here: \n" + str(_farmer_reference_link), BwApi.BW_API_MB_OK)

                elif (callbackId == 98):
                    #Close window
                    BwApi.WndHTMLClose(handle)

                elif (callbackId == 99):
                    #Debbuging message prompt trigger
                    BwApi.WndMessageBox(str(dataString), BwApi.BW_API_MB_OK)

                return 0

        def Func0():
            time.sleep(5)

            global _plugin_path
            loop = 0

            for location in sys.path:
                if (re.search('main', location)):
                    _plugin_path = sys.path[loop-1]
                
                loop += 1

            BwApi.UpdateSessionFunctionRequest_v2('com.trapdoor.stage3d', 0, "Func0")
            
            i=0

            global _zmienna
            global _history_garment_id
            global _history_colorway_id
            global _stage_open
            global _stage_open_process
            global _action_listener_on
            global _model_path
            global _file_ext
            global _include_avatar

            global _batch_renderer
            global _batch_renderer_json_import
            global _batch_renderer_export_params
            global _batch_renderer_currentItem

            global _farmer_cloud_rendering
            global _farmer_url
            global _farmer_reference_link
            global _farmer_user_uid

            global _temp_export_settings

            while i == 0:
                #print('STAGE Trigger var:', _zmienna)
                #BwApi.UpdateSessionFunctionRequest_v2('com.trapdoor.stage3d', 99, "---> Loop: " + str(_zmienna))
                if _zmienna == 0:
                    print('Waiting for task')
                elif _zmienna == 2:
                    BwApi.UpdateSessionFunctionRequest_v2('com.trapdoor.stage3d', 11, "Action Listener")
                    _zmienna = 0
                elif _zmienna == 3:
                    BwApi.UpdateSessionFunctionRequest_v2('com.trapdoor.stage3d', 3, "Update Endpoints")
                    _zmienna = 0

                elif _zmienna == 10:
                    if not os.path.exists(_batch_renderer_json_import["output_path"]):
                        os.makedirs(_batch_renderer_json_import["output_path"])

                    _batch_renderer_renderings_array = []

                    #_temp_export_folder = tempfile.TemporaryDirectory(dir = _model_path)
                    _temp_export_folder = tempfile.TemporaryDirectory()

                    _update_status_file(1, 35, "Preparing for render: <br>Exporting colorways", 0)
                    for colorway in _batch_renderer_json_import["ColowayIds"]:

                        _batch_renderer_export_params["path"] = os.path.join(os.path.normpath(_temp_export_folder.name), _batch_renderer_json_import["Name"] + '_' + _API_Colorway_array[colorway]["Name"] + _file_ext)
                                        
                        BwApi.UpdateSessionFunctionRequest_v2('com.trapdoor.stage3d', 11, colorway)

                        while _zmienna != 11:
                            time.sleep(1)

                        BwApi.UpdateSessionFunctionRequest_v2('com.trapdoor.stage3d', 12, "Saving 3D")

                        while _zmienna != 12:
                            time.sleep(1)

                        _update_status_file(1, 50, "Preparing for render: <br>Exporting colorways", 0)

                        if _batch_renderer_json_import["Type"] == "Still":
                            for camera in _batch_renderer_json_import["CameraPresets"]:
                                _batch_renderer_single_job = dict()
                                _batch_renderer_single_job["Name"] = _batch_renderer_json_import["Name"]
                                _batch_renderer_single_job["Type"] = _batch_renderer_json_import["Type"]
                                _batch_renderer_single_job["Resolution"] = _batch_renderer_json_import["Resolution"]
                                _batch_renderer_single_job["AlphaMask"] = _batch_renderer_json_import["renderAlpha"]
                                _batch_renderer_single_job["AutoFrame"] = _batch_renderer_json_import["AutoFrame"]

                                _temp_settings = dict()
                                _temp_settings["ModelFile"] = _batch_renderer_export_params["path"]
                                _temp_settings["CurrentScene"] = _batch_renderer_json_import["CurrentScene"]
                                _temp_settings["CurrentHDR"] = _batch_renderer_json_import["CurrentSceneHDR"]
                                _temp_settings["CurrentLightRig"] = _batch_renderer_json_import["LightRigs"]

                                temp_camera = dict()
                                temp_camera = json.loads(camera)
                                _batch_renderer_single_job["OutputFile"] = os.path.join(_batch_renderer_json_import["output_path"], _batch_renderer_json_import["Name"] + '_' + _API_Colorway_array[colorway]["Name"] + '_' + temp_camera["name"] + '.png')
                                _batch_renderer_single_job["CameraPresetToApply"] = temp_camera["value"]
                                #_temp_settings["CurrentCameraPreset"] = temp_camera["value"]
                                
                                _batch_renderer_single_job["Settings"] = _temp_settings

                                _batch_renderer_renderings_array.append(_batch_renderer_single_job)

                        else:
                            _batch_renderer_single_job = dict()
                            _batch_renderer_single_job["Name"] = _batch_renderer_json_import["Name"]
                            _batch_renderer_single_job["Type"] = _batch_renderer_json_import["Type"]
                            _batch_renderer_single_job["Resolution"] = _batch_renderer_json_import["Resolution"]

                            _temp_settings = dict()
                            _temp_settings["ModelFile"] = _batch_renderer_export_params["path"]
                            _temp_settings["CurrentScene"] = _batch_renderer_json_import["CurrentScene"]
                            _temp_settings["CurrentHDR"] = _batch_renderer_json_import["CurrentSceneHDR"]
                            _temp_settings["CurrentLightRig"] = _batch_renderer_json_import["LightRigs"]


                            _temp_settings["CurrentAnimation"] = _batch_renderer_json_import["Animations"]
                            _batch_renderer_single_job["OutputFile"] = os.path.join(_batch_renderer_json_import["output_path"], _batch_renderer_json_import["Name"] + '_' + _API_Colorway_array[colorway]["Name"] + '.mp4')
                            _batch_renderer_single_job["Settings"] = _temp_settings
                            _batch_renderer_renderings_array.append(_batch_renderer_single_job)



                    _batch_renderer["uid"] = _farmer_user_uid
                    _batch_renderer["Renderings"] = _batch_renderer_renderings_array

                    with open(os.path.join(os.path.normpath(_temp_export_folder.name), "API.json"), 'w') as _API_file:
                        json.dump(_batch_renderer, _API_file)

                    print(str(_batch_renderer_json_import)) 
                    if _batch_renderer_json_import["render_location"] == "Cloud":
                        _farmer_cloud_rendering = True
                        #print("True")
                    else:
                        _farmer_cloud_rendering = False
                        #print("False")
                    
                    if _farmer_cloud_rendering:
                        #print("Begining of f@rmer")
                        ####### F@RMER Addition ######
                        farmer = Farmer(_farmer_url)

                        #print("F@rmer declared")
                        # create JobCollection
                        jobCollectionUUID = farmer.createJobCollection()

                        _farmer_message = '{"source": "Browzwear plugin ver. 1.2.5","uid": "' + str(_farmer_user_uid) + '"}'

                        data = {
                            "message": _farmer_message,  # this is going to be save in DB job.message
                            "taskID": "app-3",  # this is an TaskID so node will know which task to run
                            "jobCollectionUUID": jobCollectionUUID,  # this is a job collection id it can be set to "" (empty string) or int number but it always have to be included.
                            "UID": _farmer_user_uid
                        }

                        _update_status_file(1, 75, "Preparing for render: <br>Compressing data", 0)

                        farmer.createJob(data)

                        print("Farmer job created")

                        # get link from RF_MS  to track job progess
                        _farmer_reference_link = farmer.getLink()

                        print("Connection Link: " + str(_farmer_reference_link))

                        print("TEMP Path: " + str(os.path.normpath(_temp_export_folder.name)))

                        shutil.make_archive(os.path.join(_model_path, "STAGE_job"),'zip',os.path.normpath(_temp_export_folder.name))

                        files = [os.path.join(_model_path, "STAGE_job.zip")]

                        for file in files:

                            farmer.pushFile(file)

                        farmer.releaseJob()

                        ####### F@RMER Addition ######
                    else:
                        param_path = '-Settings=\"' + os.path.join(os.path.normpath(_temp_export_folder.name), 'API.json') + '\"'
                        #proc = subprocess.Popen(['%s -Settings="%s"' % (_stage_path, os.path.join(os.path.normpath(_temp_export_folder.name), 'API.json'))], shell=True)   
                        proc = subprocess.Popen([_stage_path, param_path])
                    _update_status_file(1, 50, "Cleaning up..", 0)
                    BwApi.UpdateSessionFunctionRequest_v2('com.trapdoor.stage3d', 14, "Clean-up")
                    while _zmienna == 12:
                        if not _farmer_cloud_rendering:
                            poll = proc.poll()
                            if poll is not None:
                                _temp_export_folder.cleanup()
                                _zmienna = 0
                        else:
                            _temp_export_folder.cleanup()
                            _zmienna = 0
                            webbrowser.open(str(_farmer_reference_link))
                            #BwApi.UpdateSessionFunctionRequest_v2('com.trapdoor.stage3d', 15, "Communicate link")
                    BwApi.UpdateSessionFunctionRequest_v2('com.trapdoor.stage3d', 98, "Closing Window")

                elif _zmienna == 11:
                    #print("Changing Colorway")
                    BwApi.UpdateSessionFunctionRequest_v2('com.trapdoor.stage3d', 12, "Saving 3D")
                    _zmienna = 0

                if (_stage_open == 1) & (_action_listener_on == 1):
                    _stage_open_poll = _stage_open_process.poll()
                    if _stage_open_poll is not None:
                        _stage_open = 0
                    else:
                        #print("STAGE is open: ",_stage_open," Action Listener: ", _action_listener_on)
                        BwApi.UpdateSessionFunctionRequest_v2('com.trapdoor.stage3d', 9, "Action Listener")

                time.sleep(3)

        def open_settings_window():
            global handle
            global _include_avatar
            global _action_listener_on
            global _stage_path
            global _file_path
            global _APIKey
            global _model_path

            style = json.dumps({"allow_resize": False,
                                "enable_maximize": False,
                                "enable_minimize": False}
                            )
            handle = BwApi.WndHTMLCreateUrl('/index.html?avatar_on=' + str(_include_avatar) + '&updates_on=' + str(_action_listener_on) + '&stage_path=' + str(_stage_path) + '&model_path=' + str(_model_path) + '&APIKey=' + str(_APIKey),
                                            'STAGE Settings',
                                            style,
                                            rect
                                            )

            #BwApi.WndHTMLEventRegister(handle, CREATE, sessionCallback, 0)
            BwApi.WndHTMLEventRegister(handle, CLOSE, sessionCallback, 0)
            BwApi.WndHTMLEventRegister(handle, MSG, sessionCallback, 7)
            BwApi.WndHTMLEventRegister(handle, UNCAUGHT_EXCEPTION, sessionCallback, 0)

        def open_rendering_window():
            if (_APIKey != ''):
                global handle
                global _include_avatar
                global _action_listener_on
                global _stage_path
                global _file_path

                style = json.dumps({"allow_resize": False,
                                    "enable_maximize": False,
                                    "enable_minimize": False}
                                )
                handle = BwApi.WndHTMLCreateUrl('/API.html',
                                                'STAGE Render Setup',
                                                style,
                                                rect1
                                                )

                #BwApi.WndHTMLEventRegister(handle, CREATE, sessionCallback, 0)
                #BwApi.WndHTMLEventRegister(handle, CLOSE, sessionCallback, 0)
                BwApi.WndHTMLEventRegister(handle, MSG, sessionCallback, 10)
                BwApi.WndHTMLEventRegister(handle, UNCAUGHT_EXCEPTION, sessionCallback, 0)
            else:
                BwApi.WndMessageBox("API Key is not set - please go to STAGE plugin settings and fill API Key field!", BwApi.BW_API_MB_OK)

        def _update_API_endpoints():

            global _plugin_path

            global _history_garment_id
            global _API_Colorway_array

            global _farmer_cloud_rendering
            global _farmer_reference_link
            global _farmer_user_uid

            global _model_path

            _API_Colorway_array.clear()

            # ------>  PRODUCTION !!!!!!! <---------
            _API_URL = "https://us-central1-stage-3782d.cloudfunctions.net/"
            _API_Headers = {"Authorization": "Bearer " + _APIKey}
            # print(_API_Headers)
            # _API_ListEndpoints = 'ListEndpoints'

            _API_PluginEndpoint = 'Vstitcher'

            ##########  !!!!!!!!!!!!!!!!!!!!!!!

            #  CREATE in DB REFERENCE PER PLUGIG (so only plugin used endpoints are returned)

            ##########  !!!!!!!!!!!!!!!!!!!!!!

            _API_Object = {'somekey': 'somevalue'}

            try:
                _API_Return_Endpoints = requests.post(url = _API_URL + _API_PluginEndpoint, headers = _API_Headers, timeout = 2)
                #print("Status: ", _farmer_user_uid.status_code)
                if (_API_Return_Endpoints.status_code != 200):
                    BwApi.WndHTMLClose(handle)
                    BwApi.WndMessageBox("You are not authorized to use this feature. Please check you plugin settings and make sure you have the right API Key.", BwApi.BW_API_MB_OK)
                    return
                _farmer_user_uid = json.loads(_API_Return_Endpoints.text)["UID"]
                pass
            except requests.Timeout:
                time.sleep(2)
                _API_Return_Endpoints = requests.post(url = _API_URL + _API_PluginEndpoint, headers = _API_Headers, timeout = 5)
                if (_API_Return_Endpoints.status_code != 200):
                    BwApi.WndHTMLClose(handle)
                    BwApi.WndMessageBox("You are not authorized to use this feature. Please check you plugin settings and make sure you have the right API Key.", BwApi.BW_API_MB_OK)
                    return
                _farmer_user_uid = json.loads(_API_Return_Endpoints.text)["UID"]
                pass
            except requests.ConnectionError:
                print("Connection Failed")
                BwApi.WndMessageBox("Connection to STAGE API server failed. Please try again.", BwApi.BW_API_MB_OK)

                pass

            _plugin_dictionary = dict()

            for _API_endpoint in json.loads(_API_Return_Endpoints.text):
                print("Receiving... <---- " + str(_API_endpoint))
                if _API_endpoint == 'UID':
                    continue

                _plugin_data_struct = dict()
                _plugin_data_struct["Name"] = _API_endpoint
                _plugin_data_struct["Data"] = json.loads(_API_Return_Endpoints.text)[_API_endpoint]
                _plugin_dictionary[_API_endpoint] = _plugin_data_struct

            garment_id = BwApi.GarmentId()
            _API_ColorwayIds = BwApi.GarmentColorwayIds(garment_id)


            for colorway in _API_ColorwayIds:
                #print("Generating thumbnail... <---- " + str(colorway))
                BwApi.ColorwayThumbnailExtract(garment_id, colorway, os.path.join(_plugin_path, 'web', 'temp', str(colorway) + '.jpg'))

                _API_Colorway_array[str(colorway)] = dict()
                _API_Colorway_array[str(colorway)]["Name"] = BwApi.ColorwayNameGet(garment_id, colorway)
                _API_Colorway_array[str(colorway)]["Thumb"] = os.path.join('temp', str(colorway) + '.jpg')

            _plugin_dictionary["ColowayIds"] = _API_Colorway_array
            _plugin_dictionary["Name"] = str(BwApi.GarmentNameGet(garment_id))
            _plugin_dictionary["output_path"] = str(_model_path)
            _plugin_dictionary["IncludeAvatar"] = str(_include_avatar)

            with open(os.path.join(_plugin_path, 'web', 'dane.js'), 'w') as _API_file:
                _API_file.write("var dane=" + json.dumps(_plugin_dictionary) + ";")

            _update_status_file(1, 0, "Preparing job for render...", 0)
            #################################

        def _update_status_file(_loaded, _progress, _msg, _finished):
            with open(os.path.join(_plugin_path, 'web', 'status.json'), 'w') as _API_file:
                _API_file.write('{"Loaded": "' + str(_loaded) + '","Progress": ' + str(_progress) + ', "msg": "'+ _msg +'","Finished": "' + str(_finished) + '"}')

        def _reload_avatar(gar_id, snap_id, col_id):
            BwApi.ColorwayCurrentSet(gar_id, col_id)
            BwApi.SnapshotLoad(gar_id, snap_id)

        def BwApiPluginInit():
            BwApi.MenuFunctionAdd('Launch STAGE', sessionCallback, 2)
            BwApi.MenuFunctionAdd('Update model', sessionCallback, 1)
            BwApi.MenuFunctionAdd('Render with STAGE', sessionCallback, 6)
            BwApi.MenuFunctionAdd('Settings...', sessionCallback, 5)
            BwApi.MenuFunctionAdd('About STAGE...', sessionCallback, 8)
            BwApi.UpdateSessionFunctionSet_v2(sessionCallback)

            t0 = threading.Thread(target=Func0)
            t0.start()

            BwApi.EventRegister(callbackEvent, 0, BwApi.BW_API_EVENT_COST_BANNER_CLICK)

            return 1;

        sessionCallback = SessionCallback()
        callbackEvent = CallbackEvent()
